namespace Programming_CSharp
{
	using System;
	using System.Diagnostics;
	using System.IO;
	using System.Reflection;

	// ġũ Ǵ  
	public class MyMath
	{
		//  ̿Ͽ  Ѵ.
		public int DoSumLooping(int initialVal)
		{
			int result = 0;
			for(int i = 1;i <=initialVal;i++)
			{
				result += i;
			}
			return result;
		}
	}

	// BruteForceSums Ŭ ϰ    
	// DoSums ޼ҵ带  ȣѴ.

	public class ReflectionTest
	{
		// ̹  ȣǴ  ޼ҵ
		public double DoSum(int theValue)
		{
			//   Ŭ   ,
			//   Ѵ.
			if (theType == null)
			{
				GenerateCode(theValue);
			}

			//  Ͽ  
			//   Ŭ ȣ ϴ. 
			object[] arguments = new object[0];
			object retVal =
				theType.InvokeMember("ComputeSum",
				BindingFlags.Default | 
				BindingFlags.InvokeMethod,
				null,
				theClass,
				arguments);
			return (double) retVal;
		}

		// ڵ带 Ͽ Ѵ.
		private void GenerateCode(int theVal)
		{
			// ϱ   .
			string fileName = "BruteForceSums";
			Stream s = 
				File.Open(fileName + ".cs", FileMode.Create);
			StreamWriter wrtr = new StreamWriter(s);
			wrtr.WriteLine(
				"// Dynamically created BruteForceSums class");
			// Ŭ Ѵ.
			string className = "BruteForceSums";
			wrtr.WriteLine("class {0}", className);
			wrtr.WriteLine("{");

			// ޼ҵ带 Ѵ.
			wrtr.WriteLine("\tpublic double ComputeSum()");
			wrtr.WriteLine("\t{");
			wrtr.WriteLine("\t// Brute force sum method");
			wrtr.WriteLine("\t// For value = {0}", theVal);

			// ܼ  ϱ  ڵ带 Ѵ. 
			wrtr.Write("\treturn 0");
			for (int i = 1;i<=theVal;i++)
			{
				wrtr.Write("+ {0}",i);
			}
			wrtr.WriteLine(";");    // ޼ҵ带 Ѵ. 
			wrtr.WriteLine("\t}");    // ޼ҵ带 ݴ´.
			wrtr.WriteLine("}");    // Ŭ ݴ´. 

			// streamWriter  ݴ´. 
			wrtr.Close();
			s.Close();

			//  Ѵ. 
			ProcessStartInfo psi = 
				new ProcessStartInfo();
			psi.FileName = "cmd.exe";

			string compileString = "/c csc /optimize+ ";
			compileString += "/target:library ";
			compileString += "{0}.cs > compile.out";

			psi.Arguments = 
				String.Format(compileString, fileName);
			psi.WindowStyle = ProcessWindowStyle.Minimized;

			Process proc = Process.Start(psi);
			proc.WaitForExit();    // ִ 2  Ѵ.

			//   ޼ҵ  Ű ͸ ޴´. 
			Assembly a = 
				Assembly.LoadFrom(fileName + ".dll");
			theClass = a.CreateInstance(className);
			theType = a.GetType(className);
			// File.Delete(fileName + ".cs");  //  Ѵ.
		}
		Type theType = null;
		object theClass = null;
	}

	public class TestDriver
	{
		public static void Main()
		{
			const int val = 200;  // 1..200
			const int iterations = 100000;
			double result = 0;

			// ġŷ 
			MyMath m = new MyMath(); 
			DateTime startTime = DateTime.Now;            
			for (int i = 0;i < iterations;i++)
			{
				result = m.DoSumLooping(val);
			}
			TimeSpan elapsed = 
				DateTime.Now - startTime;
			Console.WriteLine(
				"Sum of ({0}) = {1}",val, result);
			Console.WriteLine(
				"Looping. Elapsed milliseconds: \n" + 
				elapsed.TotalMilliseconds + 
				"for {0} iterations", iterations);

			// ݿ ̿ ڵ  
			ReflectionTest t = new ReflectionTest();

			startTime = DateTime.Now; 
			for (int i = 0;i < iterations;i++)
			{
				result = t.DoSum(val);
			}

			elapsed = DateTime.Now - startTime;
			Console.WriteLine(
				"Sum of ({0}) = {1}",val, result);
			Console.WriteLine(
				"Brute Force. Elapsed milliseconds: \n" + 
				elapsed.TotalMilliseconds  + 
				"for {0} iterations", iterations);
		}
	}
}