using System;
using System.Net.Sockets;


public class AsynchNetworkServer
{
  
	class ClientHandler
	{
		public ClientHandler( Socket socketForClient )
		{
			socket = socketForClient;
			buffer = new byte[256];
			networkStream = 
				new NetworkStream(socketForClient);

			callbackRead =
				new AsyncCallback(this.OnReadComplete);

			callbackWrite =
				new AsyncCallback(this.OnWriteComplete);
		}

		// Ŭ̾Ʈ ڿ б Ѵ.
		public void StartRead()
		{
			networkStream.BeginRead(
				buffer, 0, buffer.Length, 
				callbackRead, null);
		}

		// бⰡ  ڿ ֿܼ ϰ,
		// ٽ Ŭ̾Ʈ Ѵ.
		private void OnReadComplete( IAsyncResult ar )
		{
			int bytesRead = networkStream.EndRead(ar);

			if( bytesRead > 0 )
			{
				string s = 
					System.Text.Encoding.ASCII.GetString(
						buffer, 0, bytesRead);
				Console.Write( 
					"Received {0} bytes from client: {1}", 
					bytesRead, s );
				networkStream.BeginWrite(
					buffer, 0, bytesRead, callbackWrite, null);
			}
			else
			{
				Console.WriteLine( "Read connection dropped");
				networkStream.Close();
				socket.Close();
				networkStream = null;
				socket = null;
			}
		}

		// ڿ   ޽ ϰ б⸦ Ѵ.
		private void OnWriteComplete( IAsyncResult ar )
		{
			networkStream.EndWrite(ar);
			Console.WriteLine( "Write complete");
			networkStream.BeginRead(
				buffer, 0, buffer.Length, 
				callbackRead, null);
		}

		private byte[]          buffer;
		private Socket          socket;
		private NetworkStream   networkStream;
		private AsyncCallback   callbackRead;
		private AsyncCallback   callbackWrite;
	}


	public static void Main()
	{
		AsynchNetworkServer app = 
			new AsynchNetworkServer();
			app.Run();
	}

	private void Run()
	{
		// TcpListener  ϰ Ѵ.
		// (65000 Ʈ)
		TcpListener tcpListener = new TcpListener(65000);
		tcpListener.Start();       

		//   ݺϸ鼭  ٸ.
		for (;;)
		{
			// Ŭ̾Ʈ ϸ
			// socketForClient ̸ ο  ȯϰ,
			// tcpListener  Ѵ.
			Socket socketForClient = 
				tcpListener.AcceptSocket();
			if (socketForClient.Connected)
			{
				Console.WriteLine("Client connected");
				ClientHandler handler = 
					new ClientHandler(socketForClient);
				handler.StartRead();
			}
		}
	}
}

